#include <stdio.h>
#include "commands.h"

/* 	TODO:
	Fix this bug 
	---------------
	> dump xfoo
	foo: 0x50
	bar: 0x51
	goo: 0x52
	lin: 0x53
	win: 0x54
	syntax error
	syntax error
	syntax error
	syntax error
	syntax error
	syntax error
	syntax error
	syntax error
	> 
	It should only print syntax error once.

	Fix this bug
	---------------
	> dump rboo
	> 
	It should print unknown register.

*/

	
void do_help(void) {
	printf("CLI v0.01 help page\n");
	printf("\n");
	printf("\n");
	printf("Available commands:\n");
	printf("\n");
	printf("help - prints this page.\n");
	printf("dump - dumps all registers .\n");
	printf("dump <regname>- dumps specified register .\n");
	printf("dump <addr> - dumps 32 bytes at specified address .\n");
	printf("dump <addr> <len> - dumps specifed bytes at specified address .\n");
	printf("dump <addr> <width> - dumps specifed number of locations at specified address.\n");
	printf("                      width specifies bitwidth. A zero width dumps in char format .\n");

}

char pseudomem[] = "1. This is a test.  Now is the time for all"
				   "good men to come to the aid of their "
				   "country.  The quick brown fox jumped "
				   "over the lazy dog."
				   "2. This is a test.  Now is the time for all"
				   "good men to come to the aid of their "
				   "country.  The quick brown fox jumped "
				   "over the lazy dog."
				   "3. This is a test.  Now is the time for all"
				   "good men to come to the aid of their "
				   "country.  The quick brown fox jumped "
				   "over the lazy dog."
				   "4. This is a test.  Now is the time for all"
				   "good men to come to the aid of their "
				   "country.  The quick brown fox jumped "
				   "over the lazy dog."
				   "5. This is a test.  Now is the time for all"
				   "good men to come to the aid of their "
				   "country.  The quick brown fox jumped "
				   "over the lazy dog."
				   "6. This is a test.  Now is the time for all"
				   "good men to come to the aid of their "
				   "country.  The quick brown fox jumped "
				   "over the lazy dog."
				  ;

void do_reg_dump(char* word) {

	if (NULL == word) {
		printf("rfoo: 0x50\n");
		printf("rbar: 0x51\n");
		printf("rgoo: 0x52\n");
		printf("rlin: 0x53\n");
		printf("rwin: 0x54\n");
	} else {
		if (0 == strcmp("foo",word)) {
				printf("rfoo: 0x50\n");
		} else if (0 == strcmp("bar",word)) {
				printf("rbar: 0x51\n");
		} else if (0 == strcmp("goo",word)) {
				printf("rgoo: 0x52\n");
		} else if (0 == strcmp("lin",word)) {
				printf("rlin: 0x53\n");
		} else if (0 == strcmp("win",word)) {
				printf("rwin: 0x54\n");
		}
		free(word);
	}

}

/* %[flags][width][.prec][size][type] 
   %  0#8x */      
void do_mem_dump(int addr, int len, int width) {

	int i,j,hwidth,cols;	
	int offset;
	unsigned char *pchBuf;
	unsigned short *psBuf;
	void *pvBuf;


	//printf("do_mem_dump(%d,%d,%d)\n",addr,len,width);

	/* A 0 width specifes char printing. Thus, hwidth is the hacked width. */
	hwidth = (width) ?  width : 8;
	/* Normally print 8 entries, but in case of ascci text print 40. */
	cols = (width) ?  8 : 40;
	if (8 == width || 0 == width) 
		pvBuf =  (unsigned char * ) (pseudomem + addr);
	else if (16 == width)
		pvBuf =  (unsigned short * ) (pseudomem + addr);
	else if (32 == width)
		pvBuf =  (unsigned long * ) (pseudomem + addr);
	else {
		printf("Error in width. Should not happen\n");
		return ;
	}

	for(i=0; i<len/hwidth; i++) {
		printf("%04d: ",(width)?hwidth*i:cols*i);
		for(j=0; j<cols; j++) {
			if (8 == width) 
				printf("%0#4x ", *((unsigned char *)pvBuf)++);
			else if (0 == width)
				printf("%c", *((unsigned char *)pvBuf)++);
			else if (16 == width)
				printf("%0#6x ", *((unsigned short *)pvBuf)++);
			else if (32 == width)
				printf("%0#8x ", *((unsigned long *)pvBuf)++);
		}
		printf("\n");
	}

	printf("\n");

}


void do_quit(void) {
	exit(0);

}



int main(int argc, char *argv[]) {
	int val;
	printf("CLI Start.\n");
	printf("> ");

	while(1) {

		val = yyparse();

		if (1 == val) {
			printf("syntax error\n");
		} else {
			printf("> ");
		}

	}

	/* never reached */
	printf("CLI End.  val = %d\n ", val);

	return 0;
}

